<?php

/*
    This file is part of Spip-clone.

    Spip-clone is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Spip-clone is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Trad-Lang; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Copyright 2004
		Mathieu Lutfy <mathieu@bidon.ca>

	$Id: inc_bazar.php,v 1.3 2005/08/16 17:01:29 bgm Exp $
*/

if (defined("_INC_BAZAR")) return;
define("_INC_BAZAR", "1");


// ** Pris de inc_filtres.php3 (Spip) **
function nettoyer_varsimple($texte) {
	// securite & uniformisation en minuscules (et _) des codes de langue
	return strtolower(eregi_replace("[^a-z0-9_\-]", "", $texte));
}

// ** Pris de inc_filtres.php3 (Spip) **
// Transforme n'importe quel champ en une chaine utilisable
// en PHP ou Javascript en toute securite
// < ? php $x = '[(#TEXTE|texte_script)]'; ? >
// [ML] Je pense que son inclusion de inc_version.php a changé entre 
// les versions de 1.8.x..
if (! function_exists("texte_script")) {
	function texte_script($texte) {
		$texte = str_replace('\\', '\\\\', $texte);
		$texte = str_replace('\'', '\\\'', $texte);
		return $texte; 
	}
}

function get_squels() {
	global $conf_spipsquels;
	$ret = array();

	$handle = opendir($conf_spipsquels);
	while (($fichier = readdir($handle)) != '') {
		// Eviter ".", "..", ".htaccess", etc.
		if ($fichier[0] == '.') continue;
		if ($fichier == 'CVS') continue;

		$chemin_complet = $conf_spipsquels . "/" . $fichier;

		if (is_dir($chemin_complet))
			$ret[$fichier] = $fichier; // simplifie le "<select>"
	}

	closedir($handle);
	return $ret;
}

function get_listusers() {
	$ret = array();

	if (is_file("/etc/passwd")) {
		$users = shell_exec("grep -v root /etc/passwd | cut -d ':' -f 1");
		$users_arr = explode("\n", $users);

		while (list($idl, $val) = each($users_arr)) {
			$ret[$val] = $val; // simplifie le "select"
		}
	}

	return $ret;
}

function html_tete($titre = "", $taille = 550) {
	global $pgm_nom;

	if ($titre)
		$titre = $pgm_nom . " / " . $titre;
	else 
		$titre = $pgm_nom;

	include('inc_html_tete.php');
	echo "<h1>" . $titre . "</h1>\n";
}

function html_pied($titre = "", $taille = 550) {
	global $pgm_nom;
	global $pgm_version;

	include('inc_html_pied.php');
}

function html_td($contenu = "", $align = "left", $colspan = 1) {
	echo "\t<td align='" . $align . "' colspan='" . $colspan . "'>" . $contenu . "</td>\n";
}

function markup($tag, $contenu = "", $class = "", $style = "") {
	echo "<" . $tag;
	if ($class) echo " class='" . $class . "'";
	if ($style) echo " style='" . $style . "'"; 
	echo ">" . $contenu . "</". $tag . ">\n";
}

function debut_html_form($name = "form", $method = "post", $etape = "", $action = "") {
	echo "<form method='" . $method . "' name='" . $name . "'";
	if ($action != "")
		echo " action='" . $action . "'";
	echo ">\n";

	if ($etape != "") {
		echo "<input type='hidden' name='etape' value='" . $etape . "'>\n";
	}
}

function fin_html_form() {
	echo "</form>\n";
}

function get_html_select($name = "select", $options, $select_opt = "", $select_default = "") {
	// on retourne le resultat pour utilisation dans un <TD>
	$ret = "<select style='width:100%;' name='" . $name . "' " . $select_opt . ">\n";

	asort($options);
	reset($options);

	while (list($idl, $val) = each($options)) {
		if ($val) {
			$selected = ($val == $select_default ? " selected" : "");
			$ret .= "<option value='" . $idl . "'" . $selected . ">" . $val . "</option>\n";
		}
	}

	$ret .= "</select>\n";
	return $ret;
}

function get_html_checkbox($name = "indices[]", $options, $select_opt = "") {
	$ret = "";

	asort($options);
	reset($options);

	while (list($idl, $val) = each($options)) {
		if ($val) {
			$ret .= "<div><input id='" . $idl . "' "
				. "type='checkbox' name='" . $name . "' value='" 
				. $idl . "'><label for='" . $idl . "'>" . $val . "</label></div>\n";
		}
	}

	return $ret;
}

function get_html_form_item($type = "text", $name = "item", $value ="", $opt = "") {
	$ret = "<input type='" . $type . "' name='" . $name . "' value='" .  $value . "'";
	if (! empty($opt))
		$ret .= " " . $opt . " ";
	
	$ret .= ">";
	return $ret;
}

// Rien trouve de mieux: http://www.phpbuilder.com/columns/akent20000610.php3?page=6
function date_add($interval, $number, $date) {
	$date_time_array = getdate($date);
	$hours = $date_time_array['hours'];
	$minutes = $date_time_array['minutes'];
	$seconds = $date_time_array['seconds'];
	$month = $date_time_array['mon'];
	$day = $date_time_array['mday'];
	$year = $date_time_array['year'];

	switch ($interval) {
		case 'a':
			$year += $number;
			break;
		case 'm':
			$month += $number;
			break;
		case 'j':
			$day += $number;
			break;
		case 'h':
			$hours += $number;
			break;
		case 'n':
			$minutes += $number;
			break;
		case 's':
			$seconds += $number; 
			break;            
	}

	return mktime($hours,$minutes,$seconds,$month,$day,$year);
}


